#include <fcntl.h> 
#include <termios.h>
#include <stdio.h> 
#include <fstream> 
#include <stdlib.h> 
#include <time.h>
#include <iostream>
#include <string>
#include <vector>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <TH1D.h>
#include <TGraph.h>
#include <TCanvas.h>
#include <TApplication.h>

using namespace std;

int main(int argc, char *argv[]) 
{
TApplication a("a", &argc, argv);	
	
struct termios SerialOptions;

string Port = argv[1];
cout<<Port<<endl;
int FileDescriptor = open(Port.c_str(), O_RDWR | O_NOCTTY);

if(FileDescriptor == -1) 
	{
	cout<<"Error: Cannot open port "<<Port<<"!"<<endl;
	return 1;
	} 
else 
	{	
	tcgetattr(FileDescriptor, &SerialOptions);

	tcflush(FileDescriptor, TCIFLUSH);
	tcflush(FileDescriptor, TCOFLUSH);

	SerialOptions.c_cflag = CS8 | CREAD | CLOCAL | CRTSCTS;
	SerialOptions.c_oflag = 0;
	SerialOptions.c_iflag = 0;
	SerialOptions.c_lflag = 0;
	SerialOptions.c_line =  0;
	
	cfsetispeed(&SerialOptions, B9600);	
	cfsetospeed(&SerialOptions, B9600);
	tcsetattr(FileDescriptor, TCSANOW, &SerialOptions);
	}
fcntl(FileDescriptor, F_SETFL, FNDELAY); 

TGraph * GTimeCpm = new TGraph();
TGraph * GTimeDose = new TGraph();
int ctr = 0;

ofstream out("output_geiger.txt");
out.close();

unsigned int StartTime = time(0);

unsigned int LastUpload = 0;
while(1)
	{		
	char Datastream[1000];		
	read(FileDescriptor, Datastream, 1000);
	cout<<Datastream<<endl;
	string Data = Datastream;

	int FoundCpm = Data.find("CPM,")+4;
	int FoundCpmEnd = Data.find(",", FoundCpm)-FoundCpm;

	int FounduSv = Data.find("uSv/hr,")+7;
	int FounduSvEnd = Data.find(",", FounduSv)-FounduSv;
	//cout<<FounduSv<<" "<<FounduSvEnd<<" "<<Data.substr(FounduSv,FounduSvEnd)<<endl;

	if(FoundCpm >= 0 && FounduSvEnd > 1 && FoundCpmEnd > 1) 
		{
		out.open("output_geiger.txt", ios::app);	
			
		string StringCpm = Data.substr(FoundCpm,FoundCpmEnd);
		string StringDose = Data.substr(FounduSv,FounduSvEnd);
		
		out<<time(0)-StartTime<<" "<<StringCpm<<" "<<StringDose<<endl;
	
		out.close();
	
		ifstream in("output_geiger.txt");
		
		double MaxDose = 0;
		double MaxCpm = 0;
				
		if(!in.good()) cout<<"output_geiger.txt does not exist!"<<endl;
		else
			{
			unsigned int Time;
			double Cpm, Dose;
			ctr = 0;
		
			while(1)
				{
				in>>Time>>Cpm>>Dose;
				
				if(in.eof()) break;
				else 
					{
					GTimeCpm->SetPoint(ctr, Time, Cpm);
					GTimeDose->SetPoint(ctr, Time, Dose);
				
					if(Cpm > MaxCpm) MaxCpm = Cpm;
					if(Dose > MaxDose) MaxDose = Dose;
	
					ctr++;
					}
				}
			
			if(time(0)-LastUpload > 15) 
				{
				TCanvas * CTimeCpm = new TCanvas("CTimeCpm","CTimeCpm", 0,0,500,500);

				CTimeCpm->SetLeftMargin(0.15);
				CTimeCpm->SetRightMargin(0.04);
				CTimeCpm->SetTopMargin(0.04);

				GTimeCpm->GetYaxis()->SetTitleOffset(1.6);
				GTimeCpm->GetYaxis()->SetTitle("counts [1/min]");
				//GTimeCpm->GetXaxis()->SetTimeDisplay(1);
				GTimeCpm->GetXaxis()->SetNdivisions(505, false);
				//GTimeCpm->GetXaxis()->SetTimeFormat("%H:%M");
				GTimeCpm->SetMinimum(0);
				GTimeCpm->SetMaximum(MaxCpm*1.1);
				
				GTimeCpm->SetLineWidth(2);
				GTimeCpm->SetLineColor(kRed);
				GTimeCpm->SetMarkerStyle(20);
				GTimeCpm->SetMarkerColor(kRed);
				
				GTimeCpm->Draw("APL");
				
				gPad->SetGridy(1);
				gPad->SetGridx(1);
				
				CTimeCpm->SaveAs("TimeCpm.png");
				
				TCanvas * CTimeDose = new TCanvas("CTimeDose","CTimeDose", 500,0,500,500);

				CTimeDose->SetLeftMargin(0.15);
				CTimeDose->SetRightMargin(0.04);
				CTimeDose->SetTopMargin(0.04);

				GTimeDose->GetYaxis()->SetTitleOffset(1.6);
				GTimeDose->GetYaxis()->SetTitle("dose [#muSV/h]");
				//GTimeDose->GetXaxis()->SetTimeDisplay(1);
				GTimeDose->GetXaxis()->SetNdivisions(505, false);
				//GTimeDose->GetXaxis()->SetTimeFormat("%H:%M");
				GTimeDose->SetMinimum(0);
				GTimeDose->SetMaximum(MaxDose*1.1);
				
				GTimeDose->SetLineWidth(2);
				GTimeDose->SetLineColor(kRed);
				GTimeDose->SetMarkerStyle(20);
				GTimeDose->SetMarkerColor(kRed);
				
				GTimeDose->Draw("APL");
				
				gPad->SetGridy(1);
				gPad->SetGridx(1);
				
				CTimeDose->SaveAs("TimeDose.png");
				
				LastUpload = time(0);
				//system("scp TimeDose.png TimeCpm.png philipvd@hepts4.phys.hawaii.edu:public_html/temp/");
				
				tcflush(FileDescriptor, TCIFLUSH);
				tcflush(FileDescriptor, TCOFLUSH);
				}
			
			}
		in.close();		
		}
		
	sleep(2);
	
	}
	
return 0;
}
